var collins = {
    init: function () {
        var _this = this;
        _this.lastValue;
        _this.selRange;
        _this.isResume = false;
        _this.OFFSET_TOP = 22;
        template.defaults.debug = true;
        // iOS 8hack
        var oMatch = window.navigator.userAgent.match(/os\s+(\d+)/i);
        if (oMatch && oMatch[1] - 0 < 9) {
            $("#ios8").html(".def-wrap,.xref-wrap,.header-basic-entry .head-word,.exam-wrap li{overflow:hidden;}.xref-wrap .def,.xref-wrap def,.xref-wrap .tran,.def-wrap .def,.def-wrap def,.def-wrap .tran{display:block;}.xref-wrap def,.def-wrap def,.header-basic-entry .head-word hw,.header-basic-entry .head-word .word,.exam-wrap li p{padding-top:100px;margin-top:-100px;}")
        }
        // 点击弹出 - sense1第一条释义
        function popupWord(word, position) {
            var oWord = JSON.stringify({
                "word": word,
                "position": position
            });
            console.log(oWord);
            window.jsInterface.execute("cmd=pop_word&word="+word+"&position="+position);
        }
        // ex word:a
        $(document).on("tap", "xrparent a", function () {
            // var word = $(this).html();
            var word = $(this).contents().filter(function () {
                return this.nodeType != 1
            }).text();
            var $sup = $(this).find("sup");
            var position = "";
            if ($sup.length) {
                position = $sup.html();
            }
            popupWord(word, position);
        });
        // ex word -> xref-wrap xref:a
        $(document).on("tap", ".xref-wrap xref,.def-wrap xref,popup", function () {
            var word = $(this).find("xrhw").html();
            var $xrhn = $(this).parent().find("xrhn");
            var position = "";
            if ($xrhn.length) {
                position = $xrhn.html();
            }
            popupWord(word, position);
        });
        // ex word -> 点击发音
        $(document).on("tap", ".head-word .word-text,.head-word .phonetic", function () {
            var word = $(".head-word .word-text").eq(0).html();
            console.log("voice_word", word);
            window.jsInterface.execute("cmd=voice_word&word=" + word);
            /*<jdists trigger="ios">
            window.webkit.messageHandlers.voiceWord.postMessage(word);
            </jdists>*/
        });
        //点击跳转
        $(document).on("tap", "#superHeadwordContainer li", function () {
            var href = $(this).attr("data-go");
            var toT = $(href).offset().top - _this.OFFSET_TOP - collins.scrollTopGap;
            window.jsInterface.execute("cmd=scrollTo&offsetTop=" + toT);
            return false;
        })
        function postSelectionChange() {
            if (window.getSelection().toString() && _this.lastValue != window.getSelection().toString()) {
                var rect = collins.getSelectionRect();
                // document.querySelector(".super-headword-container").innerHTML = JSON.parse(rect).content + (index++);
                _this.lastValue = window.getSelection().toString();
                _this.selRange = window.getSelection().getRangeAt(0);
                console.log("lastValue:" + rect);
                window.jsInterface.execute("cmd=selection_change&rect="+rect);
            } else {
                _this.lastValue = "";
            }
        }
        // selectionChange
        var moveTimer = null;
        function selectionChange() {
            if (_this.isResume) {
                setTimeout(function () {
                    _this.isResume = false;
                }, 100);
                return;
            }
            moveTimer && (clearTimeout(moveTimer));
            moveTimer = setTimeout(function () {
                postSelectionChange();
            }, 300);
        }
        document.addEventListener("selectionchange", selectionChange, false);
        document.addEventListener("touchstart", function () {
            console.log("touchstart...");
            window.getSelection().removeAllRanges();
            document.removeEventListener("selectionchange", selectionChange, false);
            if (window.navigator.userAgent.match(/Android 8/)) {
                document.addEventListener("selectionchange", fixPixel, false);
            }
        });
        document.addEventListener("touchmove", function () {
            console.log("touchmove...");
            document.removeEventListener("selectionchange", selectionChange, false);
        });
        document.addEventListener("touchend", function () {
            console.log("touchend...");
            collins.doTouchEnd();
        });
        this.doTouchEnd = function () {
            postSelectionChange();
            document.addEventListener("selectionchange", selectionChange, false);
            if (window.navigator.userAgent.match(/Android 8/)) {
                document.removeEventListener("selectionchange", fixPixel, false);
            }
        }
        // fix pixel android8.0机器中的 12个空格导致全选bug(通过模拟 - 屏蔽第二次的全选事件)
        var lastTime;
        var lastRange;
        function fixPixel(ev) {
            var now = (new Date()).valueOf();
            var selection = window.getSelection();
            if (selection.rangeCount !== 1) {
                return;
            }
            var range = selection.getRangeAt(0);
            var text = range.toString();
            var matches = text.match(/\s/);
            console.log("=====gap" + (now - lastTime) + "========");
            console.log(window.getSelection().toString());
            if (lastTime && (now - lastTime) < 300) {
                if (matches && lastRange) {
                    selection.removeAllRanges();
                    selection.addRange(lastRange);
                } else if (matches) {
                    selection.removeAllRanges();
                }
            } else if (matches) {
                selection.removeAllRanges();
            }
            lastTime = now;
            if (!matches) {
                lastRange = range;
                return;
            }
        }
    },
    render: function (json, position, offsetTop, scrollTopGap) {
        var _this = this;
        console.log(json);
        var oBody = document.querySelector("body");
        // iOS需要设置顶部空白距离
        offsetTop && (oBody.style.paddingTop = offsetTop + "px");
        // iOS需要偏移拖拽控件距离
        this.scrollTopGap = scrollTopGap ? scrollTopGap : 0;
        if (typeof json == "string") {
            json = JSON.parse(json);
        }
        var html = template("tpl", json);
        setTimeout(function () {
            oBody.innerHTML = html;
            // 渲染后定位，柯林斯页面 蓝色链接点击全屏展开
            if (position) {
                var href = $("#superHeadword" + (position - 1));
                var toT = $(href).offset().top - _this.OFFSET_TOP - collins.scrollTopGap;
                // window.jsInterface.execute("cmd=jump_to");
                toT = Math.round(toT);
                window.jsInterface.execute("cmd=scrollTo&offsetTop=" + toT);
                return false;
            }
            //屏幕高度如果一屏能显示 如air strike，防止出现回到顶部
            var iScrollHeight = document.documentElement.scrollHeight;
            var iWinHeight = document.documentElement.clientHeight;
            if ((iScrollHeight - iWinHeight) < 52) {
                $("#mainContainer").css("padding-bottom", "0");
            }
            window.jsInterface.execute("cmd=render_done");
        }, 0);
    },
    getSelectionRect: function () {
        var json = {};
        var oSelection = window.getSelection();
        if (oSelection.toString()) {
            var selectRect = oSelection.getRangeAt(0).getBoundingClientRect();
            json.top = selectRect.top;
            json.right = selectRect.right;
            json.bottom = selectRect.bottom;
            json.left = selectRect.left;
            json.content = oSelection.toString();
            return JSON.stringify(json);
        }
    },
    removeSelection: function () {
        collins.lastValue = "";
        window.getSelection().removeAllRanges();
    },
    resumeSelection: function () {
        window.getSelection().removeAllRanges();
        collins.isResume = true;
        window.getSelection().addRange(collins.selRange);
    },
    clearRenderContent: function () {
        document.querySelector("body").innerHTML = "";
    },
    setHeadGap: function (iGap) {
        document.querySelector("body").style.paddingTop = iGap + "px";
    },
    setFootGap: function (iGap) {
        document.querySelector("body").style.paddingBottom = iGap + "px";
    },
    //设置主题
    setTheme: function (theme) {
        $("body").attr("class", "").addClass(theme);
        if (/langeasy/gi.test(window.navigator.userAgent)) {
            $("body").addClass("langeasy");
        } else {
            $("body").addClass("qlisten");
        }
    },
    // 设置字体
    setFontFamily: function (fontFamily) {
        // $("#fontFamily").text(".header-basic-entry .head-word .word,.header-basic-entry .head-word hw {font-family: " + fontFamily + ";}")
    }
};
collins.init();
$(function () {
    if (/langeasy/gi.test(window.navigator.userAgent)) {
        $("body").addClass("langeasy");
    } else {
        $("body").addClass("qlisten");
    }
});